package com.yindangu.plugin.demo.rule;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.yindangu.plugin.demo.BusinessUtil;
import com.yindangu.v3.business.plugin.business.api.rule.IRule;
import com.yindangu.v3.business.plugin.business.api.rule.IRuleContext;
import com.yindangu.v3.business.plugin.business.api.rule.IRuleOutputVo;
 
/**
 * 多值返回 数字转汉字
 * @author jiqj
 *
 */
public class NumberUpperRolue implements IRule{
    private static final Logger log = LoggerFactory.getLogger(NumberUpperRolue.class);
    
    public static final String D_Code="numberConvertRule";
    public static final String INPUT_NAME="name",INPUT_AGE="age",INPUT_SEX="sex";
    public static final String OUT_NAME="name",OUT_AGE="age",OUT_RETIRE="retire"
    		,OUT_CHINESE="chinese";

    public enum Sex{
    	male,female;
    }
    @Override
    public IRuleOutputVo evaluate(IRuleContext context) {
    	String name = String.valueOf(context.getInput(INPUT_NAME));
    	String s = String.valueOf(context.getInput(INPUT_SEX));
    	Sex sex = Sex.male;
    	if("female".equalsIgnoreCase(s)) {
    		sex = Sex.female;
    	}
    	Integer agex = (Integer)context.getInput(INPUT_AGE);
    	int age = (agex == null ? 0 : agex.intValue());
    	
    	//男性65岁才退休
    	boolean retire = (sex == Sex.male ? age>65 : age>55);
    	String chinese = BusinessUtil.toChinese(age);
    	
        log.info(NumberUpperRolue.class.getName() + ",姓名:" + context.getInput(INPUT_NAME) + ",年龄:" + age);
        IRuleOutputVo vo = context.newOutputVo();
        return vo.put(OUT_AGE, age)
        		.put(OUT_NAME, name)
        		.put(OUT_RETIRE, retire)
        		.put(OUT_CHINESE, chinese);
    }

}
