package com.yindangu.plugin.demo.rule;

import java.util.List;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.yindangu.plugin.demo.BusinessUtil;
import com.yindangu.v3.business.plugin.business.api.rule.IRule;
import com.yindangu.v3.business.plugin.business.api.rule.IRuleContext;
import com.yindangu.v3.business.plugin.business.api.rule.IRuleOutputVo;
 
/**
 * 多值返回 数字转汉字
 * @author jiqj
 *
 */
public class NumberUpperRolueEntity implements IRule{
    private static final Logger log = LoggerFactory.getLogger(NumberUpperRolueEntity.class);
    public static final String D_Code="numberConvertEntity";
    public static final String INPUT_USERLLIST="userList",INPUT_AGE="age";
    public static final String OUT_USERLLIST="userList2",OUT_COUNT="count";
    public static final String FD_AGE="age",FD_NAME="name",FD_CHINESE="chinese";
 
    @SuppressWarnings({ "unused", "unchecked", "rawtypes" })
	public IRuleOutputVo evaluate(IRuleContext context) {
    	String field = (String)context.getInput(FD_AGE);
    	List<Map> entity = (List<Map>)context.getInput(INPUT_USERLLIST);
    	//IDataView dv = (IDataView)context.getVObject().getInput(INPUT_USERLLIST);//取v原对象
    	
    	int count = 0;
    	for(Map m : entity) {
    		String name = (String)m.get(FD_NAME);
    		Integer age = (Integer)m.get(FD_AGE);
    		String chinese  = BusinessUtil.toChinese(age.intValue());
    		m.put(FD_CHINESE,chinese );
    		count++;
    	}

    	IRuleOutputVo vo = context.newOutputVo(); //VDS.getBuilder().getResponseBuilder();
        return vo.put(OUT_USERLLIST, entity)
        		.put(OUT_COUNT, count) ;
    }

}
